;- = < Fishy > = -
;By: Iambian Zenith
;==============================================\
;=== System equtes. Change info here to port.  ;\
;==============================================;|
;#include "ti83plus.inc" ;where equ came from. ;|
.org $9D93  ;RAM start executing here.         ;|
.dw  $6DBB  ;AsmPrgm, LSB incremented.         ;|
#define bcall(XXXX) rst 28h \.dw $XXXX         ;|
#define equ .equ                               ;|
#define EQU .equ                               ;|
#define TABLESIZER 30                          ;|
;ROMcalls                                      ;|
_PutC           equ $4504 ;Lrg char, adv cursr ;|
_VPutMap        equ $455E ;Sml char, adv cursr ;|
_SetXXXXOp2     equ $4792 ;HL->Op2             ;|
_OP2ToOP1       equ $4156 ;Op2->Op1            ;|
_DispOP1A       EQU $4BF7 ;Displays OP1        ;|
;RAM equates. No code executed in these areas. ;|
OP1             EQU $8478 ;Op 11 bytes. #1     ;|
OP3             EQU $848E ;Op 11 bytes. #3     ;|
appbackupscreen equ $9872 ;temporary storage   ;|
textShadow      EQU $8508 ;temp storage block  ;|
plotSScreen     equ $9340 ;screen memory       ;|
textInverse     equ 3     ; 1=disp inv bit-map ;|
textFlags       EQU 5     ;Text output flags   ;|
fontFlags       EQU 50    ;Font setting flags  ;|
fracDrawLFont   EQU 2     ;Lrg instead of smll ;|
sGrFlags        EQU 20    ;ScreenGRaph flags   ;|
textWrite       EQU 7     ;1=Smll fnt ->Buffer ;|
penCol          EQU $86D7 ;Pen X pos           ;|
penRow          EQU $86D8 ;Pen Y pos           ;|
curRow          EQU $844B ;Pen X pos           ;|
curCol          EQU $844C ;Pen Y pos           ;|
;==============================================;|
;==============================================;/
;==============================================/

fish3Flag   equ     33  ;asm_Flags_1. Not hex.

dirFlag     equ     0   ;player direction.
drawFlag    equ     1   ;SpriteRoutine's. 0=Normal OR operation. 1=XOR operation.
collision   equ     2   ;0=noSpritOverlap, 1=spriteOverlap (collided)
testmode    equ     3   ;0=drawToBuffer 1=DoNotDrawToBuffer (to check collision)


 xor a
 jr nc,programBegin
TitleZ:
.db "Fishy",$0   ;this title can be used as regular title for space saving when displaying it on title screen. (but there won't be one for debugging. Just gameplay graphics)
ProgramBegin:
 ld a,(IY+fish3Flag)
 ld (saveflag),a
 set textWrite,(IY+sGrFlags)
 ld (IY+fish3Flag),$00
 ld de,appbackupscreen
 ld hl,SpriteDataStart
 ld b,12
 push bc
  ld bc,8
  ldir
  ld bc,-8
  add hl,bc
  ld c,8
  push bc
   ld b,8
   ld c,(hl)
   rr c
   rla
   djnz $-3
  pop bc
  ld (de),a
  inc hl
  inc de
  dec c
  jr nz,$-14
 pop bc
 djnz $-29
 ld a,(tkFlag)
 or a
 jp z,$+5  ;automatic skipping in case of teacher-key event.
 jp pressKMode
programstart:
 xor a
 out ($20),a  ;6MHz on SE. Does nothin on reg.
 ld hl,VariableMass
 ld de,VariableMass+1
 ld (hl),a
 ld bc,160
 ldir
 ld (yourscore),bc
 call titleScreen
 ld hl,Instructions1
 call TextWriter
 call fastCopy
programstartLoop:
 call KeyReader
 rla    ;first NC, DEL
 jr nc,quitgame ;quit game
 rla    ;secnd NC, MODE
 jr nc,DisplayInstructions
 rla    ;third NC, 2nd
 jr nc,GameStart
 jr programstartLoop
DisplayInstructions:
 call titleScreen
 ld hl,InText1
 call TextWriter
 ld hl,delscore
 call TextWriter
 call fastCopy
DisplayInstructionsLoop:
 call KeyRead
 cp $EF
 jr z,ProgramStart
 cp $7F
 jr nz,$+10
 ld hl,0
 ld (HighScore),hl
 jr DisplayInstructions
 cp $DD
 jr nz,$+9
 call titlescreen
 ld a,11
 jr gamestart+2
 jr DisplayInstructionsLoop
quitgame:
 res textWrite,(IY+sGrFlags)
 ld (IY+fontFlags),$00
 ld a,(saveflag)
 ld (IY+fish3Flag),a
 ret

GameStart:
 ld a,2
 ld (fishSize),a

 ld hl,$4060
 ld (fishX),hl
 ld hl,$0000
 ld (fishSpeedX),hl
 xor a
 ld hl,tableSize
 ld de,tableStart
 ld (hl),$00
 ld bc,TABLESIZER*4
 ldir       ;clean out the table.
;===============================================================================
MainGameLoop:
 ld b,6
 call random
 dec a
 call z,createFish
 call cleanBuffer  ;remove contents of buffer before drawing.
 ld IX,tableStart
 ld b,TABLESIZER ;size of table
EnemyFishLoop:   ;no enemies yet.
 push bc
;IX+0 = FishX
;IX+1 = FishY
;IX+2 = FishSpeed
;IX+3 = FishSize
  ld a,(IX+2)
  or a
  jr z,EnemySkipTest
  add a,(IX+0)  ;adding speed to X pos to get new Xpos
  ld (IX+0),a  ;save new value back into FishX.
  cp 254
  jp nc,RemoveEnemyFish   ;if the number becomes negative, destroy fish
  cp 206  ;if greater, then it is greater than right bounds (too high to draw)
  jp nc,RemoveEnemyFish
EnemySkipTest:
  ld l,(IX+0)
  ld h,(IX+1)
  ld a,(IX+3)
  call drawSprite
  set testmode,(IY+Fish3Flag)
  call drawPlayerSprite
  res testmode,(IY+Fish3Flag)
  bit collision,(IY+fish3Flag)
 pop bc
 push bc
  jp nz,detectedCollision   ;fish was hit!
  ld de,4
  add ix,de  ;shunt up for next entry.
EndRemoveFish:
 pop bc
 djnz EnemyFishLoop
 call drawPlayerSprite
 call fastCopy
 call keyread
 ld b,a  ;for temp shifting...
;and getting rid of the tables for good by a bit of shifting. Remember, A is being destroyed all the time.
;utilizing keyboard output bit logic...it's memory conservative!
 rrc b \ call nc,pressKdown
 rrc b \ call nc,pressKleft
 rrc b \ call nc,pressKright
 rrc b \ call nc,pressKup
 rrc b \ jp nc,pressKYequ  ;this is the teacher key
 rrc b \ ; call nc,pressK2nd
 rrc b \ jr nc,pressKMode
 rrc b \ call nc,gameover  ;this routine will remove the entry on the stack anyway...
JumpNode01:    ;to return to the top of the loop using the smaller relative jumps. Hop-scotch across the code!
 ld hl,fishSpeedX
 ld a,(hl)
 or a
 jr z,$+11
 bit 7,a
 jr nz,$+5
 dec a
 jr $+3
 inc a
 ld (hl),a
 push hl
  call keyhorizontal
 pop hl
 inc hl
 ld a,(hl)
 or a
 jr z,$+11
 bit 7,a
 jr nz,$+5
 dec a
 jr $+3
 inc a
 ld (hl),a
 call keyvertical
 jp MainGameLoop
pressKMode:  ;pause screen on this. Remember to do a "ld b,$FF" for looper.
 ld hl,PauseText
 call TextWriter
 call fastCopy
 call KeyReader
 jr JumpNode01
pressKdown:
 ld hl,fishSpeedY
 ld a,(hl)
 add a,2
 jp m,$+7
 cp $0C
 jr nc,$+3
 ld (hl),a
 ret
pressKup:
 ld hl,fishSpeedY
 ld a,(hl)
 sub 2
 jp p,$+7
 cp $F7
 jr c,$+3
 ld (hl),a
 ret
keyVertical:
 ld hl,fishY
 or a
 jr z,$+12
 bit 7,a
 jr nz,$+8
 cp 3
 jr nc,$+4
 add a,4
 sra a
 sra a
 add a,(hl)  ;new Y pos.
 cp 97
 ret nc
 cp $FD
 ret nc
 ld (hl),a
 ret
pressKleft:
 res dirFlag,(IY+fish3Flag)
 ld hl,fishSpeedX
 ld a,(hl)
 sub 2
 jp p,$+7
 cp $F7
 jr c,$+3
 ld (hl),a
 ret
pressKright:
 set dirFlag,(IY+fish3Flag)
 ld hl,fishSpeedX
 ld a,(hl)
 add a,2
 jp m,$+7
 cp $0C
 jr nc,$+3
 ld (hl),a
 ret
keyHorizontal:
 ld hl,fishX
 or a
 jr z,$+12
 bit 7,a
 jr nz,$+8
 cp 3
 jr nc,$+4
 add a,4
 sra a
 sra a
 add a,(hl)
 cp 205
 ret nc
 cp $FD
 ret nc
 ld (hl),a
 ret
pressKYequ:
 ld a,$FF
 ld (tkFlag),a
 jp quitgame

detectedCollision:
RanIntoFish:
;IX+0 = FishX
;IX+1 = FishY
;IX+2 = FishSpeed
;IX+3 = FishSize
 ld a,(fishSize)
 ld c,(IX+3)
 srl c
 cp c
 jr c,GameOver
 jr z,FishDuel
LiveOn:
 ld de,73
 ld hl,(YourScore)
 add hl,de
 jr c,TooFat
 ld (YourScore),hl
 ld hl,nextLevel
 ld a,(hl)
 inc (hl)  ;for next HL
 cp 8
 jr nz,skipGrowBigger  ;skip growbigger code.
 ld a,(fishSize)
 inc a
 cp 11
 jr nc,SkipGrowBigger ;don't grow anymore if reached max size.
 ld (fishSize),a
 ld (hl),$0
skipGrowBigger:
 push bc
  push ix
   call displayScore
   ld hl,YourScoreText
   call textWriter
   ld hl,(YourScore)
   bcall(_SetXXXXOp2)
   bcall(_Op2toOp1)
   ld a,5
   bcall(_DispOP1A)
  pop ix
 pop bc
 call deleteFish
 jp EndRemoveFish
TooFat:
 call clearscreen
 ld hl,Ecosystem
 call textWriter
 jr GameOver+9
FishDuel:
 ld b,255
 call random
 rlca
 jr c,LiveOn
GameOver:
 call cleanbuffer
 ld hl,GameOverText
 call TextWriter
 call fastCopy
 call keyreader ;now includes nice little pause and prevents sticky keys.
 ld hl,(HighScore)
 ld de,(YourScore)
 or a
 sbc hl,de
 pop bc   ;remove the stack push earlier in the loop.
GameOver2:
 jp nc,programstart
 ld (HighScore),de
 or a
 jr GameOver2  ;

createFish:  ;this is a called routine. All registers are destroyed. (Including IX)
;IX+0 = FishX
;IX+1 = FishY
;IX+2 = FishSpeed
;IX+3 = FishSize
 ld hl,tableSize
 ld a,TABLESIZER
 dec a
 cp (hl)
 ret c   ;kill creation if too many fishy on the table.
 inc (hl)
 ld hl,tableStart+(TABLESIZER*4)-5
 ld de,tableStart+(TABLESIZER*4)-1
 ld bc,(TABLESIZER*4)-1
 lddr
 ld ix,tableStart
 ld b,10
 call random
 cp 5
 jr nc,$+14
 ld b,2
 call random
 inc a
 ld c,0
 ld h,0
 jr $+12
 ld b,2
 call random
 cpl
 ld c,206
 ld h,1
 ld (IX+0),c
 ld (IX+2),a
 ld b,10
 call random
 inc a  ;skip null sprites
 add a,a
 add a,h  ;increase on position.
 ld (IX+3),a
 ld b,98
 call random
 ld (IX+1),a
 ret

RemoveEnemyFish:
 call deleteFishCont
 jp EndRemoveFish

deleteFish:  ;calling routine must handle this one a certain way, since this is a called routine (pushing and address and jumping works)
;deletes a fish at position IX and shunts back the entire field. Erases entry at the end of the field to maintain table.
;IX+0 = FishX
;IX+1 = FishY
;IX+2 = FishSpeed
;IX+3 = FishSize
 ld l,(IX+0)
 ld h,(IX+1)
 ld a,(IX+3)
 push bc
  call drawSprite
  set drawFlag,(IY+fish3Flag)
  call drawSprite  ;kills sprite
  res drawFlag,(IY+fish3Flag)
 pop bc
deleteFishCont:
 ld hl,tableSize
 xor a
 cp (hl)
 ret z  ;kills delete routine if no fish on the table.
 dec (hl)  ;decreases by one for new table size.
 push ix
 pop de
 ld a,b
 inc a
 add a,a
 add a,a
 ld c,a
 ld h,d
 ld l,e
 inc hl \ inc hl \ inc hl \ inc hl
 ld b,0
 ldir
 xor a
 ld (de),a \ inc de
 ld (de),a \ inc de
 ld (de),a \ inc de
 ld (de),a
 ret        ;kills routine after finish.

drawPlayerSprite:
 ld a,(fishSize)
 add a,a
 bit dirFlag,(IY+fish3Flag)
 jr nz,$+3
 inc a  ;for other direction
 ld hl,(fishX)
;continuing forward to drawSprite to save on a JP drawSprite
drawSprite:  ;L=X, H=Y, flags set to OR/XOR operation. Preserves all registers, but kills the stack... :) A=spriteNumOffset
 res collision,(IY+fish3Flag)  ;reset this flag before going into the routine. Or else, there will always be a collision read.
 push af
  push hl
   srl h
   srl l
   push ix
    call drawSpriteMain
   pop ix
  pop hl
 pop af
 ret
;  set collision,(IY+fish3Flag)
;  bit drawFlag,(IY+fish3Flag)  ;1=XOR, 0=OR
;L=X H=Y A=sprite
drawSpriteMain:
 di
 ex af,af'  ;saving input sprite
 xor a
 ld c,l     ;register juggle
 ld l,h
 ld h,a
 add hl,hl  ;Y*12 for buf
 add hl,hl
 ld e,l
 ld d,h
 add hl,hl
 add hl,de  ;NC
 ld de,plotsscreen
 add hl,de
 ld b,a
 rr c       ;A=remainder-like.
 rra
 rr c
 rra
 rr c
 rla
 rla
 rla
 push bc    ;saving position
  add hl,bc
  ex de,hl ;DE now = buffer
  ex af,af'
  add a,a  ;byte offset
  add a,a
  add a,a  ;bytes small enough to do this.
  ld l,a   ;offset in HL
  ld h,0
  ld bc,Appbackupscreen  ;address
  add hl,bc              ;adding offset with address
  push de                ;saving position in buffer
   ld ix,spritebuf
   ex af,af'
   ld b,8
   ld c,a
   ld e,(hl)
   ld d,0
   or a
   jr z,$+9
   srl e
   rr  d
   dec c
   jr nz,$-5
   ld (IX+0),e
   ld (IX+1),d
   inc hl
   inc ix
   inc ix
   djnz $-25
  pop hl
 pop bc      ;save x-position wrt byte, for proper shift series. B'=0, use for flags
 exx
 ld hl,spritebuf
 ld c,(IY+fish3Flag)
 ld b,8
 exx
 ld de,12
 exx         ;switch to shadow to prep switchback
drawSpriteLoop:
;dirFlag     equ     0   ;player direction.
;drawFlag    equ     1   ;SpriteRoutine's. 0=Normal OR operation. 1=XOR operation.
;collision   equ     2   ;0=noSpritOverlap, 1=spriteOverlap (collided)

;HL=scrnBuf  C=posinfo(0-13) D=free E=11 B'=loopcounter HL'=sprtBuf C'=flags
;B=spare
 exx         ;switch back to nonshadow
 ld a,c
 or a
 jr z,dSC  ;handler for on zero edge
 dec hl    ;if not zero, then decrement HL for purposes
 exx \ ld a,(hl) \ inc hl \ exx
 cpl      ;get inverse white outline
 ld b,a   ;save cpl'd byte
 or (hl)  ;test if same material
 cp b     ;compare if line has been infringed
 exx
  jr z,$+4
  set collision,c
  bit testmode,c
 exx
 jr nz,$+15  ;do not write result back
 ld a,b
 cpl      ;set byte back to normal
 exx \ bit drawflag,c \ exx
 jr nz,$+5
 or (hl)
 jr $+3
 xor (hl)
 ld (hl),a
 inc hl   ;to write next byte
 jr dSCS
dSC:
 exx \ inc hl \ exx
 jr dSC3   ;if C=0 (left clip), jump to writing second byte
dSCS:
 ld a,c
 cp 12
 jr nz,dSC3
 exx \ inc hl \ exx
 jr dSC2
dSC3:
 exx \ ld a,(hl) \ inc hl \ exx
 cpl      ;get inverse white outline
 ld b,a   ;save cpl'd byte
 or (hl)  ;test if same material
 cp b     ;compare if line has been infringed
 exx
  jr z,$+4
  set collision,c
  bit testmode,c
 exx
 jr nz,$+15
 ld a,b
 cpl      ;set byte back to normal
 exx \ bit drawflag,c \ exx
 jr nz,$+5
 or (hl)
 jr $+3
 xor (hl)
 ld (hl),a
dSC2:
 add hl,de
 exx
 djnz drawSpriteLoop
 ld (IY+fish3Flag),C
 exx
 ret


KeyReader:
 call keyread
 inc a
 jr nz,$-4   ;wait until key release
 call keyread
 inc a
 jr z,$-4    ;wait until keypress
 dec a
 ret         ;quit with A=keypress.
KeyRead:
 ld a,$FF
 out (1),a
 push hl
 pop hl
 ld a,%10111110  ;activates grops FE and BF.
 out (1),a
 push hl
 pop hl
 in a,(1)
 ret

ClearScreen:  ;set up this way for a special reason.
 ld hl,plotSScreen
ClearScreenTwo:
 ld d,h
 ld e,l
 inc de
 ld (hl),$00
 ld bc,767
 ldir
 ret


CleanBuffer:
 di
 ld (temp2),SP
 ld SP,plotSScreen+768-84  ;don't erase the bottom part.
 ld hl,$0000
 ld b,64-6
CleanBufferLoop:
 push hl
 push hl
 push hl
 push hl
 push hl
 push hl
 djnz CleanBufferLoop
 ld SP,(temp2)
 ret

fastCopy:
 di
 exx
 ld a,$80                        ; 7
 out ($10),a                     ; 11
 out ($20),a                     ; 11  Sets first two bits to zero to slow calc down if 83pse/84xx
 ld hl,plotsscreen-12-(-(768)+1) ; 10
 ld a,$20                        ; 7
 ld c,a                          ; 4
 inc hl                          ; 6 waste
 dec hl                          ; 6 waste
fastCopyAgain:
 ld b,64                         ; 7
 inc c                           ; 4
 ld de,-(12*64)+1                ; 10
 out ($10),a                     ; 11
 add hl,de                       ; 11
 ld de,10                        ; 10
fastCopyLoop:
 add hl,de                       ; 11
 inc hl                          ; 6 waste
 inc hl                          ; 6 waste
 inc de                          ; 6
 ld a,(hl)                       ; 7
 out ($11),a                     ; 11
 dec de                          ; 6
 djnz fastCopyLoop               ; 13/8
 ld a,c                          ; 4
 cp $2B+1                        ; 7
 jr nz,fastCopyAgain             ; 10/1
 exx
 ret


;-----> Generate a random number
; input b=upper bound
; ouput a=answer 0<=a<b
; all registers are preserved except: af and bc
random:
 push   hl
 push   de
 ld hl,(rTemp)
 ld a,r
 ld d,a
 ld e,(hl)
 add    hl,de
 add    a,l
 xor    h
 ld (rTemp),hl
 sbc    hl,hl
 ld e,a
 ld d,h
randomLoop:
 add    hl,de
 djnz   randomLoop
 ld a,h
 pop    de
 pop    hl
 ret
;===========================================
;ASM Utilites
;
;
TextWriter:  ;saves three bytes, pointers precede string.
 ld e,(hl)
 inc hl
 ld d,(hl)
 inc hl
 ld a,e
 ld (PenCol),de
 ld (leftmargin),a
TextWriterLoop:
 ld a,(hl)
 inc hl
 or a
 ret z
 cp 11   ;set inverse
 jr nz,$+8
 set textinverse,(IY+textflags)
 jr skipwrite
 cp 12   ;reset inverse
 jr nz,$+8
 res textinverse,(IY+textflags)
 jr skipwrite
 cp 10
 jr nz,skipwrite-3
 ld a,(leftmargin)
 ld (PenCol),a
 ld a,(PenRow)
 add a,6
 ld (PenRow),a
 jr skipwrite
 bcall(_VPutMap)
skipwrite:
 jr TextWriterLoop
TitleScreen:
 call clearscreen
 ld hl,plotSScreen+96
 ld de,plotSScreen+97
 ld bc,11
 ld (hl),$FF
 ldir        ;draw full line
 set fracDrawLFont,(IY+fontFlags)
 ld de,$0021  ;33 pixels left, 0 down.
 ld hl,titleZ
 call TextWriter+4
 res fracDrawLFont,(IY+fontFlags)
 ld hl,Credits
 call TextWriter
DisplayScore:
 ld hl,HighScoreText
 call textWriter
 ld hl,(HighScore)
 bcall(_SetXXXXOp2)
 bcall(_Op2toOp1)
 ld a,5
 bcall(_DispOP1A)
 ret
SpriteDataStart:
Null:   .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
Fish1:  .db %00000000,%00000000,%00000000,%00000000,%00011100,%00000000,%00000000,%00000000
Fish2:  .db %00000000,%00000000,%00000000,%00001000,%00111100,%00001000,%00000000,%00000000
Fish3:  .db %00000000,%00000000,%00000000,%00111000,%00111100,%00010000,%00000000,%00000000
Fish4:  .db %00000000,%00000000,%00000000,%01011000,%01100100,%01011000,%00000000,%00000000
Fish5:  .db %00000000,%00000000,%01011000,%01101100,%01100100,%01011000,%00000000,%00000000
Fish6:  .db %00000000,%00000000,%01011100,%01100110,%01100010,%01011100,%00000000,%00000000
Fish7:  .db %00000000,%00000000,%01011110,%01100011,%01100001,%01011110,%00000000,%00000000
Fish8:  .db %00000000,%00001100,%10111110,%11100011,%11100001,%10111110,%00001100,%00000000
Fish9:  .db %00000000,%10111100,%11001010,%11000101,%11000001,%11111110,%10111100,%00000000
FishZ:  .db %10011100,%11010010,%11100101,%11100001,%11100101,%11110011,%11010010,%10011100
Haxxor: .db %11111111,%10000001,%10110101,%10110001,%10001101,%10101101,%10000001,%11111111

Instructions1:
.db $05,$1E
.db "2nd=Start",10
.db "Del=Quit",10
.db "Mode=Instructions",$0
InText1:
.db $01,$18
.db "In game, D-pad to move, Y=",10
.db "is teacher key, MODE pauses,",10
.db "any other to unpause. DEL to",10
.db "quit game. From here, get",10
.db "back to main menu with Y=.",0
GameOverText:
.db $20,$1E
.db "Game Over",$0
PauseText:
.db $15,$19
.db "*Game Paused*",10
.db "Press arrow keys",10
.db "to continue",0
Ecosystem:
.db $0A,$10
.db "Congratulations! You",10
.db "have destroyed the",10
.db "lake ecosystem ...",10
.db "GAME OVER.",10
.db "With the highest score.",0
delscore:
.db $2C,$39
.db "DEL clears high",0

Credits:
.db $01,$09
.db "By IZ, requested by DA, AW",10
.db "::DragonFire Programming::",$0
HighScoreText:
.db $01,$39
.db "High:",$0
;=====================================================================
;All routines and data areas requiring the ability of SMC goes here. |
;=====================================================================
HighScore:
.dw 0000  ;high score kept as SMC.
YourScoreText:
.db $2A,$39
.db "  Score:",$0
YourScore:
.dw 0000
VariableMass:
.dw 0,0,0,0,0,0,0,0,0,0 \.dw 0,0,0,0,0,0,0,0,0,0 ;40
.dw 0,0,0,0,0,0,0,0,0,0 \.dw 0,0,0,0,0,0,0,0,0,0 ;40
.dw 0,0,0,0,0,0,0,0,0,0 \.dw 0,0,0,0,0,0,0,0,0,0 ;40
.dw 0,0,0,0,0,0,0,0,0,0 \.dw 0,0,0,0,0,0,0,0,0,0 ;40 160
.dw 0,0,0,0,0 ;,0,0,0,0,0                          ;20


temp1       equ     variablemass
temp2       equ     temp1+2
saveflag    equ     temp2+2
tkFlag      equ     saveflag+1   ;if 0, then no key. If 1, then teacher key was hit.
rTemp       equ     tkFlag+1
nextLevel   equ     rTemp+2      ;counter to determine how many fish to eat before gaining a level
leftmargin  equ     nextLevel+2  ;left margin of the thing
spritebuf   equ     leftmargin+1
fishX       equ     spritebuf+16  ;current player X position
fishY       equ     fishX+1      ;current player Y position
fishSpeedX  equ     fishY+1      ;Speed of fish on X axis
fishSpeedY  equ     fishSpeedX+1 ;Speed of fish on Y axis
fishSize    equ     fishSpeedY+1 ;The size of the fish
padder      equ     fishSize+0  ;pads in case of programmer error of over-write.
tableSize   equ     padder+2  ;max number set at 16 in proggie.
tableStart  equ     tableSize+1

.end